package com.almworks.jira.structure.api.attribute.loader.delegate;

import com.almworks.jira.structure.api.attribute.AttributeValue;
import com.almworks.jira.structure.api.attribute.loader.ScanningAttributeContext;
import com.almworks.jira.structure.api.attribute.loader.ScanningAttributeLoader;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

public class DelegatingScanningAttributeLoader<T> extends DelegatingRowAttributeLoader<T, ScanningAttributeLoader<T>> implements ScanningAttributeLoader<T> {
  public DelegatingScanningAttributeLoader(@NotNull ScanningAttributeLoader<T> loader) {
    super(loader);
  }

  @Override
  @Nullable
  public AttributeValue<T> loadValue(@NotNull AttributeValue<T> precedingValue, @NotNull ScanningAttributeContext context) {
    return delegate().loadValue(precedingValue, context);
  }
}
