package com.almworks.jira.structure.api.effectbatch;

import com.almworks.integers.LongObjMap;
import com.almworks.integers.func.LongToLong;
import com.almworks.integers.wrappers.LongLongHppcOpenHashMap;
import com.almworks.integers.wrappers.LongObjHppcOpenHashMap;
import com.almworks.jira.structure.api.forest.raw.Forest;
import com.atlassian.annotations.Internal;

@Internal
public class RowsToReplace implements LongToLong {
  public LongObjMap<Forest> forests; // under => forest
  public LongLongHppcOpenHashMap replacements;
  public long replacingGenerator;
  public LongLongHppcOpenHashMap replacingGenerators;

  public RowsToReplace(Forest forest, long under, LongLongHppcOpenHashMap replacements, long replacingGenerator, LongLongHppcOpenHashMap replacingGenerators) {
    LongObjHppcOpenHashMap<Forest> forests = new LongObjHppcOpenHashMap<>();
    forests.put(under, forest);
    this.forests = forests;
    this.replacements = replacements;
    this.replacingGenerator = replacingGenerator;
    this.replacingGenerators = replacingGenerators;
  }

  public RowsToReplace(LongObjMap<Forest> forests, LongLongHppcOpenHashMap replacements, long replacingGenerator, LongLongHppcOpenHashMap replacingGenerators) {
    this.forests = forests;
    this.replacements = replacements;
    this.replacingGenerator = replacingGenerator;
    this.replacingGenerators = replacingGenerators;
  }

  @Override
  public long invoke(long l) {
    return replacingGenerators == null ? replacingGenerator : replacingGenerators.get(l);
  }
}
