package com.almworks.jira.structure.api.forest.action;

import com.atlassian.annotations.Internal;
import com.google.common.collect.ImmutableMap;

import java.util.Map;

import static java.lang.Boolean.TRUE;

@Internal
public class ActionParameters {
  public static final String PRIMARY_GENERATOR = "0:PrimaryGenerator";
  public static final String CONFIRM = "0:Confirm";
  public static final String STATIC_CAN_COMPETE = "0:StaticCanCompete";
  public static final String ACT = ":Act";
  public static final String PASS = ":Pass";

  public static final String IGNORE_REMOVED_ROW_MISSING = "updateSanityCheck.ignoreRemoveRowMissing";
  public static final String IGNORE_MOVED_ROW_MISSING = "updateSanityCheck.ignoreMovedRowMissing";
  public static final String IGNORE_ADD_AFTER_ROW_PROBLEMS = "updateSanityCheck.ignoreAddAfterRowProblems";

  public static final Map<String, Object> IGNORE_REMOVED_ROW_MISSING_MAP =
    ImmutableMap.<String, Object>of(IGNORE_REMOVED_ROW_MISSING, TRUE);
  public static final Map<String, Object> IGNORE_MOVED_ROW_MISSING_MAP =
    ImmutableMap.<String, Object>of(IGNORE_MOVED_ROW_MISSING, TRUE);
  public static final Map<String, Object> IGNORE_ADD_AFTER_ROW_PROBLEMS_MAP =
    ImmutableMap.<String, Object>of(IGNORE_ADD_AFTER_ROW_PROBLEMS, TRUE);

  private ActionParameters() {}
}
