package com.almworks.jira.structure.api.forest.action;

import com.atlassian.annotations.PublicApi;

@PublicApi
public interface AppliedEffect {
  long getGeneratorRowId();

  /**
   * @return {@code true} if the effect changed the "outside world", e.g. JIRA issues
   * or issue links. {@code false} if the effect changed a static part of a structure
   * or manual ordering.
   */
  boolean isExternal();

  String getDescription();

  boolean isReversible();
}
