package com.almworks.jira.structure.api.rest;

import com.almworks.jira.structure.api.pull.DataVersion;
import org.jetbrains.annotations.NotNull;

import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

@XmlRootElement
public class RestVersion {
  @XmlElement
  public int signature;

  @XmlElement
  public int version;

  public static RestVersion fromModel(@NotNull DataVersion version) {
    RestVersion r = new RestVersion();
    r.signature = version.getSignature();
    r.version = version.getVersion();
    return r;
  }

  public DataVersion toModel() {
    return new DataVersion(signature, version);
  }
}
