package com.almworks.jira.structure.api.rest.effect;

import com.almworks.jira.structure.api.forest.action.AppliedEffect;
import com.atlassian.annotations.Internal;
import org.jetbrains.annotations.NotNull;

import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

@Internal
@XmlRootElement
public class RestEffect {
  @XmlElement
  public long generatorRowId;

  @XmlElement
  public boolean external;

  @XmlElement
  public String description;

  @XmlElement
  public boolean reversible;

  @NotNull
  public static RestEffect fromAppliedEffect(@NotNull AppliedEffect effect) {
    RestEffect e = new RestEffect();
    e.generatorRowId = effect.getGeneratorRowId();
    e.external = effect.isExternal();
    e.description = effect.getDescription();
    e.reversible = effect.isReversible();
    return e;
  }
}
